# Class TCPClientImpl

java.lang.Object
org.apache.jmeter.protocol.tcp.sampler.AbstractTCPClient
org.apache.jmeter.protocol.tcp.sampler.TCPClientImpl

All Implemented Interfaces:
  `TCPClient`

public class TCPClientImpl extends AbstractTCPClient
Sample TCPClient implementation. Reads data until the defined EOL byte is reached. If there is no EOL byte defined, then reads until the end of the stream is reached. The EOL byte is defined by the property "tcp.eolByte".

## Field Summary

### Fields inherited from class AbstractTCPClient

`eolByte, useEolByte`

## Constructor Summary

Constructors
Constructor
Description
`TCPClientImpl()`

## Method Summary

Modifier and Type
Method
Description
`String`
`read(InputStream is)`
Reads data until the defined EOL byte is reached.
`void`
`write(OutputStream os, InputStream is)`
`void`
`write(OutputStream os, String s)`

### Methods inherited from class AbstractTCPClient

`getCharset, getEolByte, setCharset, setEolByte, setupTest, teardownTest`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TCPClientImpl

public TCPClientImpl()

## Method Details

### write

public void write(OutputStream os, String s) throws IOException

Parameters:
  `os` - - OutputStream for socket
  `s` - - String to write
Throws:
  `IOException` - when writing fails

### write

public void write(OutputStream os, InputStream is) throws IOException

Parameters:
  `os` - - OutputStream for socket
  `is` - - InputStream to be written to Socket
Throws:
  `IOException` - when writing fails

### read

public String read(InputStream is) throws ReadException
Reads data until the defined EOL byte is reached. If there is no EOL byte defined, then reads until the end of the stream is reached.

Parameters:
  `is` - - InputStream for socket
Returns:
  String read from socket
Throws:
  `ReadException` - exception that can contain partial response (Response until error occured)